package com.cds.service;

import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.Consumes;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import com.cds.model.Article;
import com.cds.util.ArticleCollection;
 
@Path("/article-service/")
@Produces("application/xml")
public interface ArticleService {
	
	    @GET
	    @Path("/articles")
	    @Produces({"application/xml", "application/json"})
	    public ArticleCollection getArticles(@Context HttpServletRequest request);
 
	    @GET
	    @Path("/article/{docid}")
	    @Produces({"application/xml", "application/json"})
	    public Article getArticle(@PathParam("docid") String docid,@Context HttpServletRequest request);
	    
	    @GET
	    @Path("/article/locale/{locale}")
	    @Produces({"application/xml", "application/json"})
	    public ArticleCollection getArticleByLocale(@PathParam("locale") String locale);
	    
	    
	    @GET
	    @Path("/article/bad")
	    public Response getBadRequest();
	    
	    @POST
	    @Path("/new")
		@Produces(MediaType.TEXT_HTML)
		@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
		public void newArticle(
				@FormParam("id") Integer id,
				@FormParam("docid") String docId,
				@FormParam("title") String title,
				@FormParam("body") String body,
				@FormParam("locale") String locale,
				@FormParam("permission") String permission,
				@FormParam("comments") String comments,
				@Context HttpServletResponse servletResponse
		) throws IOException;
	    
	    
	    @POST
	    @Path("/search")
		@Produces(MediaType.TEXT_HTML)
		@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
		public String searchArticles(
				@FormParam("search") String search,
				@Context HttpServletResponse servletResponse
		) throws IOException;
	    
	    
	    @POST
	    @Path("/newArticle")
	    @Produces("application/xml")
	    @Consumes("application/json")
	    public Article newArticle(Article article);
	    	 
	    

	}