package com.cds.service.impl;

import java.io.IOException;
import java.net.URI;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Request;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;

import com.cds.model.Article;
import com.cds.model.Body;
import com.cds.model.Comments;
import com.cds.model.Title;
import com.cds.repository.ArticleRepository;
import com.cds.service.ArticleService;
import com.cds.util.ArticleCollection;
import com.mongodb.CommandResult;


public class ArticleServiceImpl implements ArticleService {
	@Context
	UriInfo uriInfo;
	@Context
	Request request;

   
    public ArticleServiceImpl() {}

    @Override
    public ArticleCollection getArticles(HttpServletRequest request) {
    	String user = request.getParameter("user");
    	System.out.println("User Name : "+user);
    	ArticleRepository dao = new ArticleRepository();
    	return new ArticleCollection(dao.findAll(user));
    }

    @Override
    public Article getArticle(String docid, HttpServletRequest request) {
    	String user = request.getParameter("user");
    	System.out.println("User Name : "+user);
    	ArticleRepository dao = new ArticleRepository();
    	return dao.findArticleByID(docid, user);
    }

    @Override
    public Response getBadRequest() {
        return Response.status(Status.BAD_REQUEST).build();
    }
    
    @Override
	public void newArticle(Integer id,String docId,String title,String body,String locale,String permission,String comments,HttpServletResponse servletResponse) throws IOException {
    		Title t = new Title();
    		t.setName(title);t.setPermission(permission);
    		
    		Body b = new Body();
    		b.setContent(body);b.setPermission(permission);
    		 
    		Comments c = new Comments();
    		c.setComments(comments);c.setPermission(permission);
    		
			Article article =  new Article(id, docId, t, b, locale, c,permission);
			
			ArticleRepository dao = new ArticleRepository();
			dao.createArticle(article);
		URI uri = uriInfo.getAbsolutePathBuilder().path(id.toString()).build();
		Response.created(uri).build();
		
		servletResponse.sendRedirect("../../postArticle.jsp");
	}

	@Override
	public ArticleCollection  getArticleByLocale(String locale) {
		 
		ArticleRepository dao = new ArticleRepository();
    	return new ArticleCollection(dao.findArticleByLocale(locale));
	}

	@Override
	public Article newArticle(Article article) {
		 
		ArticleRepository dao = new ArticleRepository();
		dao.createArticle(article);
		return article;
	}

	@Override
	public String searchArticles(String search,
			HttpServletResponse servletResponse) throws IOException {
		 ArticleRepository dao = new ArticleRepository();
		 CommandResult re = dao.searchArticles(search);
		 System.out.println(re.toString());
		 return re.toString();
		
	}
 

}
